#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  RoyalBlue
#property  indicator_color2  HotPink
#property indicator_width1 2
#property indicator_width2 2
#property indicator_minimum 0
#property indicator_maximum 2

//-------------------------------------------------------------------

extern bool       alarm    =  true;
extern int        period   =  52;
extern int        maxbars  = 200;
int               arrowUP  = 110;
int               arrowDN  = 110;

//-------------------------------------------------------------------

double         ExtBuffer0[];
double         ExtBuffer1[];
double         ExtBuffer2[];
double         alertBar;


double         last;



int init()
{  
   IndicatorDigits(0);
   IndicatorBuffers(3);

   SetIndexBuffer(0,ExtBuffer1); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,arrowUP);
   SetIndexBuffer(1,ExtBuffer2); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,arrowDN);
   SetIndexBuffer(2,ExtBuffer0);

   IndicatorShortName("   ");

   return(0);
  }

int deinit()
  {

   ObjectsDeleteAll(0,OBJ_LABEL); 

   return(0);
}

int start()
{


   int    limit;
   double prev=0,current;
   double Value=0,Fish1=0;
   double price;
   double MinL=0;
   double MaxH=0;  
   


   limit = maxbars;
   for(int i=0; i<limit; i++) {
      MaxH = High[Highest(NULL,0,MODE_HIGH,period,i)];
      MinL = Low[Lowest(NULL,0,MODE_LOW,period,i)];
      price = (High[i]+Low[i])/2;
      
      if(MaxH-MinL == 0) Value = 0.33*2*(0-0.5) + 0.67*prev; 
      else Value = 0.33*2*((price-MinL)/(MaxH-MinL)-0.5) + 0.67*prev;     
      
      Value=MathMin(MathMax(Value,-0.999),0.999); 
      
      if(1-Value == 0) ExtBuffer0[i]=0.5+0.5*Fish1;
      else ExtBuffer0[i]=0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1;
     
      prev=Value;
      Fish1=ExtBuffer0[i];
   }


   bool trendUP = TRUE;
   for (i = limit; i >= 0; i--) {
      current = ExtBuffer0[i];
      prev    = ExtBuffer0[i + 1];
      
      if ((current < 0.0 && prev > 0.0) || current < 0.0) trendUP = FALSE;
      if ((current > 0.0 && prev < 0.0) || current > 0.0) trendUP = TRUE;
      
      if (trendUP) {
         ExtBuffer1[i] = 1.0;
         ExtBuffer2[i] = EMPTY_VALUE;
         if (alarm == true) {
            if (i==0 && prev != 2 && ExtBuffer1[i] == 1.0 && Bars>alertBar) {
               Alert("Trend Changing UP on ",Period()," ",Symbol());
               alertBar = Bars;
               last = 2;
            }
         }
      } 
      
      else {
         ExtBuffer2[i] = 1.0;
         ExtBuffer1[i] = EMPTY_VALUE;
         if (alarm == true) {
            if (i==0 && last != 1 && ExtBuffer2[i] == 1.0 && Bars>alertBar) {
               Alert("Trend Changing DOWN on ",Period()," ",Symbol());
               alertBar = Bars;
               last = 1;
            }
         }
      }
   }
   return(0);
}


